#ifndef _DRIVER_H_
#define _DRIVER_H_

#include <ntddk.h>

/*
typedef struct _LARGE_INTEGER_unnamed1 {
    ULONG32 LowPart;
    LONG32 HighPart;
} LARGE_INTEGER_unnamed1;

typedef union _LARGE_INTEGER {
    LARGE_INTEGER_unnamed1 u;
    LONG64 QuadPart;
} LARGE_INTEGER;
*/

typedef LARGE_INTEGER PHYSICAL_ADDRESS, *PPHYSICAL_ADDRESS;

typedef struct _MSR {
    ULONG Lo;
    ULONG Hi;
} MSR, *PMSR;

typedef struct _VMX_BASIC_MSR {
    unsigned RevId:32;
    unsigned szVmxOnRegion:12;
    unsigned ClearBit:1;
    unsigned Reserved:3;
    unsigned PhysicalWidth:1;
    unsigned DualMonitor:1;
    unsigned MemoryType:4;
    unsigned VmExitInformation:1;
    unsigned Reserved2:9;
} VMX_BASIC_MSR, *PVMX_BASIC_MSR;


typedef struct _VIRT_CPU {
    PVOID Self;
    ULONG32 ProcessorNumber;
    PVOID VMXON_va;
    PHYSICAL_ADDRESS VMXON_pa;
    PVOID VMCS_va;
    PHYSICAL_ADDRESS VMCS_pa;
    PVOID HostKernelStackBase;
    PVOID MSR_bitmap_va;
    PHYSICAL_ADDRESS MSR_bitmap_pa;
    ULONG32 State;
    /*ULONG32 Mailbox;*/
} VIRT_CPU, *PVIRT_CPU;

typedef struct _CR4_REG {
    unsigned VME        :1;            // Virtual Mode Extensions
    unsigned PVI        :1;            // Protected-Mode Virtual Interrupts
    unsigned TSD        :1;            // Time Stamp Disable
    unsigned DE         :1;            // Debugging Extensions
    unsigned PSE        :1;            // Page Size Extensions
    unsigned PAE        :1;            // Physical Address Extension
    unsigned MCE        :1;            // Machine-Check Enable
    unsigned PGE        :1;            // Page Global Enable
    unsigned PCE        :1;            // Performance-Monitoring Counter Enable
    unsigned OSFXSR     :1;            // OS Support for FXSAVE/FXRSTOR
    unsigned OSXMMEXCPT :1;            // OS Support for Unmasked SIMD Floating-Point Exceptions
    unsigned Reserved1  :2;            //
    unsigned VMXE       :1;            // Virtual Machine Extensions Enabled
    unsigned Reserved2  :18;           //
} CR4_REG, *PCR4_REG;

#endif